--- Globals.m	1 Feb 2004 14:13:30 -0000	1.1
+++ Globals.m	21 May 2004 03:33:25 -0000
@@ -10,7 +10,11 @@
 #import "Conversions.h"
 #import "PerlImports.h"
 #import "CBPerlArray.h"
-#import "mach-o/dyld.h"
+#ifdef GNUSTEP
+#import <dlfcn.h>
+#else
+#import <mach-o/dyld.h>
+#endif
 
 void CBWrapAllGlobals(void) {
     NSBundle *thisBundle;
@@ -67,10 +71,22 @@
     // Define a Perl context
     dTHX;
 
-    NSSymbol theSymbol;
     void *address;
     SV *mySV;
-    
+
+#ifdef GNUSTEP
+    address = dlsym( NULL, varName );
+    if (address) {
+        mySV = CBDerefIDtoSV(*(NSString**)address);
+        newCONSTSUB(gv_stashpv(pkgName, 0), (char *)varName+1, mySV);
+      
+        return TRUE;
+    } else {
+        return FALSE;
+    }
+#else
+    NSSymbol theSymbol;
+
     // First see if the requested symbol exists
     if (NSIsSymbolNameDefined(varName)) {
 
@@ -89,4 +105,5 @@
         return FALSE;
 
     }
+#endif /* GNUSTEP */
 }
